﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;

namespace XDGDependantCombo
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> XamDataGridData { get; set; }


        public ViewModel()
        {
            XamDataGridData = new ObservableCollection<SampleData>();
            string[] states = "New Jersey;Florida;California".Split(';');


            for (int i = 0; i < states.Count(); i++)
            {
                XamDataGridData.Add(new SampleData() { ID = i , State = states[i] });
            }
        }
    }

    public class SampleData : INotifyPropertyChanged
    {
        private int _id;
        private string _city;
        private string _state;
        private List<string> _cities;

        public int ID
        {
            get { return _id; }
            set
            {
                _id = value;
                NotifyPropertyChanged();
            }
        }
        public string City
        {
            get { return _city; }
            set
            {
                _city = value;
                NotifyPropertyChanged();
            }
        }

        public string State
        {
            get { return _state; }
            set
            {
                _state = value;
                NotifyPropertyChanged();
            }
        }

        public List<string> Cities
        {
            get { return _cities; }
            set
            {
                _cities = value;
                NotifyPropertyChanged();
            }
        }

        #region INotifyPropertyChanged Implementation
        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged([CallerMemberName] String propertyName = "")
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
        #endregion
    }

    public static class AvailableCities
    {
        public static List<string> GetFloridaCities()
        {
            return "Miami;Orlando;Jacksonville".Split(';').ToList();
        }

        public static List<string> GetNewJerseyCities()
        {
            return "Atlantic City;Trenton;Newark".Split(';').ToList();
        }

        public static List<string> GetCaliforniaCities()
        {
            return "Los Angeles;San Francisco;San Diego".Split(';').ToList();
        }
    }
}
